c--file contains machine specific statments
c
code for calib
      subroutine calib
c--dummy routine to identify the module
      return
      end
c
code for bldscy
      block data bldscy
c--define block data for disc routines (file di backup)
c
      common/ybufd/linky(1600)
      common/ydisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
      common/yfili/lfirst,nwblo,lindey(240)
c
      data nwblo/50/,lfirst/1600/
      data iacc/-1/,ilss/15/
      end
c
code for star9y
      subroutine star9y
c--initialize the disc routines
c
      li=1
      lf=1600
      call ygiv(li,lf,i)
      return
      end
c
code for xupy
      subroutine xupy(nfw,iadd,nw)
c--transfer from store to disc
c
c  nfw   address of first word to be used on disc
c  iadd  address of first word in core
c  nw    number of words to transfer
c
c--disc routines version iv, using 'link ' array as store
c  the buffers.
c
c--record 0 contains words  0   - (nwr-1)
c  record 1 contains words  nwr - (2*nwr-1)
c  and subsequent records are the same
c
c--
      common/ybufd/linky(1600)
      common/ydisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
c--
      dimension iadd(nw)
c
c--transfer the arguments to the common block
      nfwd=nfw
      nwd=nw
      nv=1
c--check if there are any more words to transfer
1200  continue
      if(nwd)1250,1250,1300
1250  continue
      return
c--calculate the record number etc. for this transfer
1300  continue
      call  xfndby
c--write some numbers
      linky(i+3)=-1
      do 2050 m=j,k
      linky(m)=iadd(nv)
      nv=nv+1
2050  continue
      go to 1200
      end
c
code for ygiv
      subroutine ygiv(iadd0,nnl,llu)
c--set up the user defined buffers
c
c  iadd0  first free address in 'link' that can be used
c  nnl	  length of user buffer area (attualmente = 800)
c  llu    first word that may be used by the user (set on return)
c
c--
      common/ybufd/linky(1600)
      common/ydisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
c
c--set the number of words per block equal to the number per record
      nwr=knwr(iacc)
      nwb=nwr
      l=(nnl-4)/(nwb+4)
      iacc=-1
      llu=iadd0
      if(l) 2500,2500,2300
2300  continue
      l=min0(l,ilss)
      iadd1=iadd0
      linky(iadd1)=-10000
      i=iadd1+4
      j=iadd1
      go to 2400
c--link the next buffer
2350  continue
      linky(i)=j
      linky(j+1)=i
      linky(i+2)=-10000
      linky(i+3)=0
      j=i
      i=i+nwb+4
      l=l-1
c--check if any more buffers can be link in
2400  continue
      if(l) 2450,2450,2350
c--set the last buffer flag
2450  continue
      linky(j+1)=-10000
      iacc=1
      llu=i
2500  continue
      return
      end
c
code for xfndby
      subroutine xfndby
c--find the required disc buffer
c
c--arguments are in the common block :
c
c  iadd1  first buffer word in 'link'
c  nfwd   current disc address
c  nwd    number of words left to transfer
c  nv     current position in the input or output array
c
c--the above variables are set on entry, and reset as necessary on exit.
c
c--the following variables are also set on exit :
c
c  i  address of the current buffer
c  j  address of the first word in the buffer for data
c  k  address of the last word in the buffer for data
c
c--the following variables must not changed :
c
c  l
c  m
c  n
c
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/ybufd/linky(1600)
      common/ydisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
c
c--check if the buffers have been allocated
      if(iacc)1050,1150,1150
c--attempt to read or write before declaring buffers
1050  continue
      write(ncwu,1100)
1100  format(' No buffers allocated to the disc routines')
      stop 47
c--calculate the record number etc. of transfers to be made
1150  continue
      nr =nfwd/ nwb
      n =nfwd-nr* nwb
c--search through the buffer list for free buffers and/or the buffer
c  containing this record
      i=linky(iadd1+1)
      j=iadd1
c--check the first buffer to see if this is the correct one
      if(nr-linky(i+2))1400,1750,1400
c--check if this is the correct buffer
1350  continue
      if(nr-linky(i+2))1400,1700,1400
c--check for a free buffer wich also indicates the end of the stack
1400  continue
      if(linky(i+2))1650,1450,1450
c--check if this is the last buffer
1450  continue
      if(linky(i+1)) 1550,1550,1500
c--pick up the next buffer
1500  continue
      j=i
      i=linky(i+1)
      go to 1350
c--rewrite the contents of the last buffer to the disc if nec.
1550  continue
      if(linky(i+3)) 1600,1650,1650
1600  continue
      m=linky(i+2)
      call ystor(m,linky(i+4),nwb)
      linky(i+3)=0
c--fetch the record of interest
1650  continue
      linky(i+2)=nr
      call yftch(nr,linky(i+4),nwb)
c--switch this buffer to the top of the buffer stack
c  all other buffers are forced one down the stack, so that the
c  least used one ends up at the end
1700  continue
      linky(j+1)=linky(i+1)
      linky(i+1)=linky(iadd1+1)
      linky(iadd1+1)=i
1750  continue
c--calculate the number of words that can be transfered from this buffer
      j=i+n+4
      k=j+nwd-1
      l=i+3+nwb
      nwd=k-l
c--check if all the words are in this buffer
      if(nwd)1850,1850,1800
1800  continue
      k=l
      nfwd=nfwd+(k-j+1)
1850  continue
      return
      end
c
code for ydump
      subroutine ydump
c--rewrite all the buffers marked for writing to the disc
c
      common/ybufd/linky(1600)
      common/ydisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
c
c--check if any buffers are allocated
      if(iacc)2800,2550,2550
c--link into the first buffer
2550  continue
      i=linky(iadd1+1)
      j=-1
c--check if the buffer required writing
2600  continue
      if(linky(i+3))2650,2700,2700
c--write the buffer out
2650  continue
      j=linky(i+2)
      call ystor(j,linky(i+4),nwb)
      linky(i+3)=0
c--check if this is the last buffer
2700  continue
      if(linky(i+1)) 2800,2800,2750
2750  continue
      i=linky(i+1)
      go to 2600
2800  continue
      return
      end
c
code for yftch
      subroutine yftch(i,j,k)
c
c--fetch data from the disc  -  this link controls the disc
c
c  i  disc address of the information in user records
c  j  array into which the data goes
c  k  number of words to read
c
c**this link is machine specific as it relates the
c  length of records seen by the user to the length
c  of hardware blocks on the disc
c
c--
      common/xdisu/ncdfu ,ndfle,irecx,ldaf,nbytes
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension j(512)
      common /unitbak/ jdirbak
c
c**machine specific - relates the block length to the user record length
      n=i+1
      read(unit=jdirbak,rec=n,iostat=ier,err=1010)(j(m),m=1,k)
      return
1010  continue
      l=kwlnt(k)
      do 1015 m=1,l
      j(m)=0
1015  continue
      write(unit=jdirbak,rec=n,iostat=ier,err=1030)(j(m),m=1,l)
      return
1030  continue
      call xwarni
      write(ncwu,1020) ier,jdirbak
1020  format(' yftch: ',i5,' error - unit =',i5,
     *       '. File protected or disk full.')
      call zerr
      stop 101
      end
c
code for ystor
      subroutine ystor(i,j,k)
c--store data on the disc - this link controls the disc
c
c  i  disc address of the information in user records
c  j  address in store into which the data goes
c  k  number of words to read
c
c**this link is machine specific as it relates the
c  length of records seen by the user to the length
c  of hardware blocks on the disc
c
c--the transfer is rounded up to fill one or more disc blocks
c
c--
      common/xdisu/ncdfu ,ndfle,irecx,ldaf,nbytes
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension j(512)
      common /unitbak/ jdirbak
c
c**machine specific - relates block length to the user record length
      m=kwlnt(k)
      n=i+1
      write(unit=jdirbak,rec=n,iostat=ier,err=1010) (j(l),l=1,m)
      return
1010  continue
      write(ncwu,1020) ier
1020  format(' xstor: ',i5,' error.',
     *	     ' File protected or disk full.')
      call zerr
      stop 201
      return
      end
c
code for setfiy
      subroutine setfiy(lstart)
c--initialize the binary disc file
c  by creating the first file index
c
      character*60 ititle
      common/compd/ititle
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common/yfili/lfirst,nwblo,lindey(240)
c
c--find the initial constants
c      write(ncwu,*) ' xfile = ',
c     1 ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
c      write(lo,*) ' xfili = ',lfirst,nwblo
      do i=1,nwblo
      lindey(i)=-10000
      enddo
      i=infle
      j=nwblo
      k=j+i
      lstart=lfirst+k
      lindey(1)=lfirst+k
      lindey(2)=i
      lindey(3)=lfirst+j
      lindey(4)=j
      m=11
      lindey(5)=m
      lindey(6)=nwfle
      lindey(8)=ifile
      lindey(9)=ifile
      read(ititle,1000)(lindey(l),l=m,m+14)
1000  format(15a4)
c--write(ncwu,*)'lfirst..',lfirst,(lindey(l),l=1,10)
      call xupy (lfirst,lindey,j)
      m=infle/nwfle-1
      lindey(1)=ifile
      lindey(2)=m
      lindey(3)=lfirst+j
      lindey(4)=lfirst+k-1
      lindey(5)=nwfle
      lindey(6)=i
      l=nwfle+1
      do 1010 i=1,m
      do 1010 k=1,nwfle
      lindey(l)=0.0
      l=l+1
1010  continue
      i=lindey(6)
      call xupy (lindey(3),lindey,i)
      call ydump
      return
      end
c
c--code for savelist
      subroutine savelist
c--backup binary file
c
      character*60 ifilin
      character*60 idfle,stfle,filex
      common/cdisu/idfle,stfle
      common/xdisu/ncdfu ,ndfle,irecx,ldaf,nbytes
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common /unitbak/ jdirbak
      common /yfili/ lfirst,nwblo,lindey(240)
      common /xfile/ ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      dimension lcurrc(1)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
!
!-- set up internal structures
      call star9y
      k=index(idfle,'.bin')
      ifilin=idfle(1:k)//'sav'
      jdirbak=51
      itipe=0
      kop = kopen(jdirbak,ifilin,ldaf,itipe,ierr)
      if (kop.lt.0) then
	  write(ncwu,190) ierr,ifilin(1:Lung(ifilin))
  190     format(' Open Error ',i5,'  on file ',a)
	  stop 301
      else
	  call setfiy(lstart)
      endif
!
!--loop on the list
      lcurr=lstart
      il =lindey(5)
      do iln=1,lindey(2)
	  call srlin (iln,lsn,lixx,ljxx,lpb,ll)
	  if (lixx.gt.0) then
	      call xrsl
	      lpby=lpb
	      call sldl(iln,ly,lfw,llw)
	      if(lpby.gt.0) then
	      call xdwn(lixx,istore(lfw),ll)
	      endif
	      lfwy=lcurr
	      llwy=lfwy+ll
	      lcurr=llwy
	      llwy=llwy-1
	      lpb=0
	      call xupy(lfwy,istore(lfw),ll)
	      i=iln*il+1
	      lindey(i	)=iln
	      lindey(i+1)=lsn
	      lindey(i+2)=lfwy
	      lindey(i+3)=llwy
	      lindey(i+4)=lpby
	      lindey(i+5)=ll
          endif
      enddo
      j=lindey(6)
      call xupy (lindey(3),lindey,j)
      lcurrc(1)=lcurr
      call xupy (lfirst,lcurrc,1)
      call ydump
      close(jdirbak)
      return
      end
c
code for star9
      subroutine star9
c--initialize the disc routines
c
      li=1
      lf=1600
      call xgiv(li,lf,i)
      return
      end
c
code for xrsl                                                             
      subroutine xrsl                                                     
c--reset the store limits                                                 
c                                                                         
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
c--                                                                       
      nfl=nflmx                                                           
      lfl=lflmx                                                           
      nl=nlmx                                                             
      return                                                              
      end                                                                 
c
code for xdwn                                                             
      subroutine xdwn(nfw,iadd,nw)                                        
c--transfer from disc to store                                            
c                                                                         
c  nfw   address of first word to be used on the disc                     
c  iadd  address of first word in core                                    
c  nw    number of words to transfer                                      
c                                                                         
c--disc routines version iv, using 'link ' array as store                 
c  the buffers.                                                           
c                                                                         
c--record 0 contains words  0   - (nwr-1)                                 
c  record 1 contains words  nwr - (2*nwr-1)                               
c  and subsequent records are the same                                    
c                                                                         
c--                                                                       
      common/xbufd/link(1600)                                             
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn    
c                                                                         
      dimension iadd(nw)                                                  
c                                                                         
c--transfer the arguments to the common block                             
      nfwd=nfw                                                            
      nwd=nw                                                              
      nv=1                                                                
c--check if there are any more words to transfer                          
1200  continue                                                            
      if(nwd) 1250,1250,1300                                              
1250  continue                                                            
      return                                                              
c--calculate the record number etc. for this transfer                     
1300  continue                                                            
      call xfndb                                                          
c--read some numbers                                                      
      do 1950 m=j,k                                                       
      iadd(nv)=link(m)                                                    
      nv=nv+1                                                             
1950  continue                                                            
      go to 1200                                                          
      end                                                                 
c                                                                         
code for xup                                                              
      subroutine xup(nfw,iadd,nw)                                         
c--transfer from store to disc                                            
c                                                                         
c  nfw   address of first word to be used on disc                         
c  iadd  address of first word in core                                    
c  nw    number of words to transfer                                      
c                                                                         
c--disc routines version iv, using 'link ' array as store                 
c  the buffers.                                                           
c                                                                         
c--record 0 contains words  0   - (nwr-1)                                 
c  record 1 contains words  nwr - (2*nwr-1)                               
c  and subsequent records are the same                                    
c                                                                         
c--                                                                       
      common/xbufd/link(1600)                                             
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn    
c--                                                                       
      dimension iadd(nw)                                                  
c                                                                         
c--transfer the arguments to the common block                             
      nfwd=nfw                                                            
      nwd=nw                                                              
      nv=1                                                                
c--check if there are any more words to transfer                          
1200  continue                                                            
      if(nwd)1250,1250,1300                                               
1250  continue                                                            
      return                                                              
c--calculate the record number etc. for this transfer
1300  continue
      call  xfndb
c--write some numbers
      link(i+3)=-1
      do 2050 m=j,k
      link(m)=iadd(nv)
      nv=nv+1
2050  continue
      go to 1200
      end
c
code for ydwn
      subroutine ydwn(nfw,mpri,nw)
c--transfer from disc to store
c
c  nfw   address of first word to be used on the disc
c  mpri  address of first word in core
c  nw    number of words to transfer
c
c--disc routines version iv, using 'link ' array as store
c  the buffers.
c
c--record 0 contains words  0   - (nwr-1)
c  record 1 contains words  nwr - (2*nwr-1)
c  and subsequent records are the same
c
c--
      common/xbufd/link(1600)
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ istore(1000000)
c
c--transfer the arguments to the common block
      nfwd=nfw
      nwd=nw
      nv=1
      ipri=mpri
c--check if there are any more words to transfer
1200  continue
      if(nwd) 1250,1250,1300
1250  continue
      return
c--calculate the record number etc. for this transfer
1300  continue
      call xfndb
c--read some numbers
      do 1950 m=j,k
      istore(ipri)=link(m)
      ipri=ipri+1
      nv=nv+1
1950  continue
      go to 1200
      end
c
code for yup
      subroutine yup(nfw,mpri,nw)
c--transfer from store to disc
c
c  nfw   address of first word to be used on disc
c  mpri  address of first word in core
c  nw    number of words to transfer
c
c--disc routines version vi, using 'link ' array as store
c  the buffers.
c
c--record 0 contains words  0   - (nwr-1)
c  record 1 contains words  nwr - (2*nwr-1)
c  and subsequent records are the same
c
c--
      common/xbufd/link(1600)
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ istore(1000000)
c
c--transfer the arguments to the common block
      nfwd=nfw
      nwd=nw
      nv=1
      ipri=mpri
c--check if there are any more words to transfer
1200  continue
      if(nwd)1250,1250,1300
1250  continue
      return
c--calculate the record number etc. for this transfer
1300  continue
      call  xfndb
c--write some numbers
2000  continue
      link(i+3)=-1
      do 2050 m=j,k
      link(m)=istore(ipri)
      ipri=ipri+1
      nv=nv+1
2050  continue
      go to 1200
      end
c
code for xgiv
      subroutine xgiv(iadd0,nnl,llu)
c--set up the user defined buffers
c
c  iadd0  first free address in 'link' that can be used
c  nnl    length of user buffer area
c  llu    first word that may be used by the user (set on return)
c
c--
      common/xbufd/link(1600)
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
c
c--set the number of words per block equal to the number per record
      nwr=knwr(iacc)
      nwb=nwr
      l=(nnl-4)/(nwb+4)
      iacc=-1
      llu=iadd0
      if(l) 2500,2500,2300
2300  continue
      l=min0(l,ilss)
      iadd1=iadd0
      link(iadd1)=-10000
      i=iadd1+4
      j=iadd1
      go to 2400
c--link the next buffer
2350  continue
      link(i)=j
      link(j+1)=i
      link(i+2)=-10000
      link(i+3)=0
      j=i
      i=i+nwb+4
      l=l-1
c--check if any more buffers can be link in
2400  continue
      if(l) 2450,2450,2350
c--set the last buffer flag
2450  continue
      link(j+1)=-10000
      iacc=1
      llu=i
2500  continue
      return
      end
c
code for xfndb
      subroutine xfndb
c--find the required disc buffer
c
c--arguments are in the common block :
c
c  iadd1  first buffer word in 'link'
c  nfwd   current disc address
c  nwd    number of words left to transfer
c  nv     current position in the input or output array
c
c--the above variables are set on entry, and reset as necessary on exit.
c
c--the following variables are also set on exit :
c
c  i  address of the current buffer
c  j  address of the first word in the buffer for data
c  k  address of the last word in the buffer for data
c
c--the following variables must not changed :
c
c  l
c  m
c  n
c
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xbufd/link(1600)
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
c
c--check if the buffers have been allocated
      if(iacc)1050,1150,1150
c--attempt to read or write before declaring buffers
1050  continue
      write(ncwu,1100)
1100  format(42h1no buffers allocated to the disc routines)
      stop 46
c--calculate the record number etc. of transfers to be made
1150  continue
      nr =nfwd/ nwb
      n =nfwd-nr* nwb
c--search through the buffer list for free buffers and/or the buffer
c  containing this record
      i=link(iadd1+1)
      j=iadd1
c--check the first buffer to see if this is the correct one
      if(nr-link(i+2))1400,1750,1400
c--check if this is the correct buffer
1350  continue
      if(nr-link(i+2))1400,1700,1400
c--check for a free buffer wich also indicates the end of the stack
1400  continue
      if(link(i+2))1650,1450,1450
c--check if this is the last buffer
1450  continue
      if(link(i+1)) 1550,1550,1500
c--pick up the next buffer
1500  continue
      j=i
      i=link(i+1)
      go to 1350
c--rewrite the contents of the last buffer to the disc if nec.
1550  continue
      if(link(i+3)) 1600,1650,1650
1600  continue
      m=link(i+2)
      call xstor(m,link(i+4),nwb)
      link(i+3)=0
c--fetch the record of interest
1650  continue
      link(i+2)=nr
      call xftch(nr,link(i+4),nwb)                                        
c--switch this buffer to the top of the buffer stack                      
c  all other buffers are forced one down the stack, so that the           
c  least used one ends up at the end                                      
1700  continue                                                            
      link(j+1)=link(i+1)                                                 
      link(i+1)=link(iadd1+1)                                             
      link(iadd1+1)=i                                                     
1750  continue                                                            
c--calculate the number of words that can be transfered from this buffer  
      j=i+n+4                                                             
      k=j+nwd-1                                                           
      l=i+3+nwb                                                           
      nwd=k-l                                                             
c--check if all the words are in this buffer                              
      if(nwd)1850,1850,1800                                               
1800  continue                                                            
      k=l                                                                 
      nfwd=nfwd+(k-j+1)                                                   
1850  continue                                                            
      return                                                              
      end                                                                 
c                                                                         
code for xdump                                                            
      subroutine xdump                                                    
c--rewrite all the buffers marked for writing to the disc                 
c                                                                         
      common/xbufd/link(1600)                                             
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn    
c                                                                         
c--check if any buffers are allocated                                     
      if(iacc)2800,2550,2550                                              
c--link into the first buffer                                             
2550  continue                                                            
      i=link(iadd1+1)                                                     
      j=-1                                                                
c--check if the buffer required writing                                   
2600  continue                                                            
      if(link(i+3))2650,2700,2700                                         
c--write the buffer out                                                   
2650  continue                                                            
      j=link(i+2)                                                         
      call xstor(j,link(i+4),nwb)                                         
      link(i+3)=0                                                         
c--check if this is the last buffer                                       
2700  continue                                                            
      if(link(i+1)) 2800,2800,2750                                        
2750  continue                                                            
      i=link(i+1)                                                         
      go to 2600                                                          
2800  continue                                                            
      return                                                              
      end                                                                 
c                                                                         
code for xftch                                                            
      subroutine xftch(i,j,k)                                             
c--fetch data from the disc  -  this link controls the disc               
c                                                                         
c  i  disc address of the information in user records                     
c  j  array into which the data goes                                      
c  k  number of words to read                                             
c                                                                         
c**this link is machine specific as it relates the                        
c  length of records seen by the user to the length                       
c  of hardware blocks on the disc                                         
c                                                                         
c--                                                                       
      common/xdisu/ncdfu ,ndfle,irecx,ldaf,nbytes
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension j(512)
c
c**machine specific - relates the block length to the user record length
      n=i+1
      read(unit=ncdfu,rec=n,iostat=ier,err=1010)(j(m),m=1,k)
      return
1010  continue
      l=kwlnt(k)
      do 1015 m=1,l
      j(m)=0
1015  continue
      write(unit=ncdfu,rec=n,iostat=ier,err=1030)(j(m),m=1,l)
      return
1030  continue
      call xwarni
      write(ncwu,1020) ier
1020  format(' xftch: ',i5,' error')
      call zerr
      stop 100
      end
c
code for xstor
      subroutine xstor(i,j,k)
c--store data on the disc - this link controls the disc
c
c  i  disc address of the information in user records
c  j  address in store into which the data goes
c  k  number of words to read
c
c**this link is machine specific as it relates the
c  length of records seen by the user to the length
c  of hardware blocks on the disc
c
c--the transfer is rounded up to fill one or more disc blocks
c                                                                         
c--                                                                       
      common/xdisu/ncdfu ,ndfle,irecx,ldaf,nbytes
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension j(512)
c
c**machine specific - relates block length to the user record length
      m=kwlnt(k)
      n=i+1                                                               
      write(unit=ncdfu,rec=n,iostat=ier,err=1010) (j(l),l=1,m)
      return
1010  continue
      call xwarni
      write(ncwu,1020) ier
1020  format(' xstor: ',i5,' error')                                      
      call zerr                                                           
      stop 200                                                            
      end                                                                 
c                                                                         
code for kwlnt                                                            
      function kwlnt(in)                                                  
c--assigns the number of words to complete a record                       
      i=knwr(in)                                                          
      kwlnt=(in+i-1)/i*i                                                  
      return                                                              
      end                                                                 
c                                                                         
code for knwr                                                             
      function knwr(in)                                                   
c--number of words per record                                             
c                                                                         
c**machine specific - number of integer words per user record             
c                                                                         
c--                                                                       
      knwr=512                                                            
      return                                                              
      end                                                                 
c
code for setfi
      subroutine setfi
c--initialize the binary disc file
c  by creating the first file index
c
      character*60 ititle
      common/compd/ititle
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common/xfili/lfirst,nwblo,lindex(240)
      common/xdisu/ncdfu ,ndfle,irecx,ldaf,nbytes
c
c--find the initial constants
      do 990 i=1,nwblo
      lindex(i)=-10000
990   continue
      i=infle
      j=nwblo
      k=j+i
      lindex(1)=lfirst+k
      lindex(2)=i
      lindex(3)=lfirst+j
      lindex(4)=j                                                         
      m=11                                                                
      lindex(5)=m                                                         
      lindex(6)=nwfle                                                     
c--   lindex(7)=irecx
      lindex(8)=ifile
c--next words is to indicate the last version of caos
      lindex(9)=ifile
      read(ititle,1000)(lindex(l),l=m,m+14)
1000  format(15a4)
c--	write(ncwu,*)'lfirst..',lfirst,(lindex(l),l=1,10)
      call xup (lfirst,lindex,j)
      m=infle/nwfle-1                                                     
      lindex(1)=ifile                                                     
      lindex(2)=m                                                         
      lindex(3)=lfirst+j                                                  
      lindex(4)=lfirst+k-1                                                
      lindex(5)=nwfle                                                     
      lindex(6)=i                                                         
      l=nwfle+1                                                           
      do 1010 i=1,m                                                       
      do 1010 k=1,nwfle                                                   
      lindex(l)=0.0                                                       
      l=l+1                                                               
1010  continue                                                            
      i=lindex(6)
c--	write(ncwu,*)' dopo...',lindex(3),i,lindex
      call xup (lindex(3),lindex,i)                                       
      call xdump                                                          
      call sldf                                                           
      return                                                              
      end                                                                 
c                                                                         
code for sldf                                                             
      subroutine sldf                                                     
c--load the  file index                                                   
c                                                                         
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      if(jsldf(in)) 1010,1005,1005
1005  continue
      return
1010  continue
c--error because the file index has been corrupted
      call xline
      call xwarni
      write(ncwu,1020)
1020  format(34h the file index has been corrupted)
      call zerr
      stop 1111
      end                                                                 
c                                                                         
code for jsldf                                                            
      function jsldf(in)                                                  
c--load the details of the file index when beginning to use a file        
c                                                                         
      character*60 ititle
      common/compd/ititle
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common/xfili/lfirst,nwblo,lindex(240)
c--
      jsldf=0
      call xdwn(lfirst,lindex,10)
c--	write(ncwu,*)'lfirst(1)..',lfirst,(lindex(l),l=1,10)
      i=lindex(4)
      call xdwn (lfirst,lindex,i)
c--	write(ncwu,*)'lfirst(2)..',lfirst,i,(lindex(l),l=1,i)
      j=lindex(5)
      write(ititle,1000)(lindex(k),k=j,j+14)
1000  format(15a4)
      i=lindex(2)                                                         
      call xdwn (lindex(3),lindex,i)
c--	write(ncwu,*)'lfirst(3)..',lindex(3),i,(lindex(i),i=1,i)
c--check that the file index is correctly set up or  has been
c  corrupted                                                              
      if(lindex(1)-ifile) 1010,1005,1010                                  
1005  continue                                                            
      return                                                              
1010  continue                                                            
      jsldf=-1                                                            
      go to 1005                                                          
      end                                                                 
c                                                                         
code for xlc                                                              
      subroutine xlc                                                      
c--initial subroutine to load all the file index information              
c                                                                         
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine              
c                                                                         
      if(icfle)1000,1010,1010                                             
1000  continue                                                            
      call sldf                                                           
      icfle=1                                                             
1010  continue                                                            
      return                                                              
      end                                                                 
c                                                                         
code for xnxtf                                                            
      subroutine xnxtf(ll)                                                
c--assign the next free location                                          
c                                                                         
      common/xfili/lfirst,nwblo,lindex(240)                               
      dimension  locc(1)
      call xdwn(lfirst, locc,1)
      ll= locc(1)
      return                                                              
      end                                                                 
c                                                                         
code for snxtf                                                            
      subroutine snxtf(ll)                                                
c--write the value of ^ll^  as the new next free location                 
c                                                                         
      common/xfili/lfirst,nwblo,lindex(240)                               
      dimension  locc(1)
       locc(1)=ll
      call xup(lfirst,locc,1)
      call xdump                                                          
      return                                                              
      end                                                                 
c                                                                         
code for srdn                                                             
      subroutine srdn                                                     
c--read the compound name or title                                        
c                                                                         
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common/xfili/lfirst,nwblo,lindex(240)
      common/xchar/id,ie,ib(2),ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      dimension itemp(40)
c--                                                                       
      call xdwn(lfirst,lindex,10)
      i=lindex(4)                                                         
      call xdwn (lfirst,lindex,i)                                         
      j=lindex(5)
      do 1000 k=1,40
      itemp(k)=ib(1)
1000  continue
      nc=keq(nc,ib,2)
      nc=kne(nc,ib,2)                                                     
      n=80-nc+1                                                           
      call scomp(image(nc),itemp,n)
      do 1010 k=1,20
      lindex(j)=itemp(k)
      j=j+1                                                               
1010  continue                                                            
      call xup (lfirst,lindex,i)                                          
      call xdump                                                          
      i=lindex(2)                                                         
      call xdwn (lindex(3),lindex,i)                                      
c--check that the file index is correctly set up or  has been             
c  corrupted                                                              
      if(lindex(1)-ifile) 1020,1030,1020                                  
1030  continue                                                            
      return                                                              
1020  continue                                                            
c--error because the file index has been corrupted                        
      call xline                                                          
      call xwarni
      write(ncwu,1040)                                                    
1040  format(34h the file index has been corrupted)                       
      call zerr                                                           
      stop 1111                                                           
      end                                                                 
c                                                                         
code for sprtn                                                            
      subroutine sprtn                                                    
c--print the name together with the page flips etc.
c
      character*60 ititle
      common/compd/ititle
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      call xlc
      call prtdate(ititle)
      return
      end
c
code for swlin
      subroutine swlin (iln,lsn,lfw,llw,lpb,ll)
c--write the entry for a newly created list into the file index
c
c  iln  the list type number
c  lsn  the list serial number
c  lfw  first word accupied by the list
c  llw  last word occupied by the list
c  lpb  the lenght of the preamble block for a block type list
c  ll   list lenght
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xfili/lfirst,nwblo,lindex(240)
c
      call xlc
      if (iln) 1000,1000,1010
1000  continue
      call xwarni
      write(ncwu,1001) iln
1001  format(///,i7,25h is not a valid list type)                         
      call zerr                                                           
      stop  1111                                                          
1010  continue                                                            
      mln=lindex(2)                                                       
      il =lindex(5)                                                       
      if(iln-mln) 1030,1030,1000                                          
1030  continue                                                            
      i=iln*il+1                                                          
      lindex(i  )=iln                                                     
      lindex(i+1)=lsn                                                     
      lindex(i+2)=lfw                                                     
      lindex(i+3)=llw                                                     
      lindex(i+4)=lpb                                                     
      lindex(i+5)=ll
      j=lindex(6)
      call xup (lindex(3),lindex,j)
      if(istat2.le.2) return
      call xprth
      call xprtl(lindex(i),il)
      return
      end
c
code for srlin
      subroutine srlin (iln,lsn,lfw,llw,lpb,ll)
c--read the entry  for a list in the current index table
c
c  iln  the list type number
c  lsn  the list serial number
c  lfw  first word occupied by the list
c       'lfw' is set negative if no such list exists
c  llw  last word occupied by the list
c  lpb  the lenght of the preamble block for a block type list
c  ll   list lenght
c
      common/xfili/lfirst,nwblo,lindex(240)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      if(iln)1020,1020,1000
1000  continue
      call xlc
      mln=lindex(2)
      il =lindex(5)
      if(iln-mln) 1010,1010,1020
1010  continue
      i=iln*il+1
      if(lindex(i)) 1020,1020,1040
1020  continue
      lfw=-1
1030  continue
      if(istat2.le.2) return
      call xprth
      call xprtl(lindex(i),il)
      return
1040  continue
      lsn=lindex(i+1)
      lfw=lindex(i+2)
      llw=lindex(i+3)
      lpb=lindex(i+4)
      ll=lindex(i+5)
      go to 1030
      end
c
code for xxcln
      subroutine xxcln(in)
c--set on the store the first values of the list @in@
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common /xdata/ store(1000000)
c
      store(nfl  )=float(iend)
      store(nfl+1)=float(in)
      store(nfl+2)=1.0
      store(nfl+3)=0.0
      store(nfl+4)=-1.0
      return
      end
c
code for xfrml
      subroutine xfrml (iln, n)
c--form a list
c
c  iln list number
c  n   the lenght of the list
c
c  the list is assumed to begin at @nfl@
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
c
      ln=n
      call sowl(ln,iln,lsn,lfw,llw,lpb,ll)
      if (iln) 1000,1000,1030
1000  write(ncwu,1010) iln
1010  format(/,i7,' is not a valid list type')
      call zerr
      return
1030  continue
      store(nfl+2)=lsn
      call yup(lfw,nfl,n )
      call swlin(iln,lsn,lfw,llw,lpb,ln)
      call xdump
      return
      end                                                                 
c                                                                         
code for sowl                                                             
      subroutine sowl  (lcl,iln,lsn,lfw,llw,lpb,ll)                       
c--write or overwrite a list on the disc                                  
c                                                                         
c  lcl  lenght that has to be written                                     
c  iln  list number                                                       
c  lsn  list serial number                                                
c  lfw  location of first word on the disc                                
c  llw  location of the last word on the disc                             
c  lpb  lenght of the preamble block of the list to be overwritten        
c  ll   list lenght                                                       
c                                                                         
c--find the list of this type                                             
      lsn=0                                                               
      call srlin (iln,lsn,lfw,llw,lpb,ll)                                 
      if(lfw) 1020,1020,1010                                              
c--check if the current list is of the right lenght                       
1010  continue                                                            
      if(ll-lcl) 1020,1060,1060                                           
c--list can not be overwritten                                            
c--find the next free location                                            
1020  continue                                                            
      call xnxtf(ll)                                                      
      lfw=ll                                                              
      llw=lfw+lcl
      call snxtf(llw)                                                     
      llw=llw-1                                                           
      lpb=0                                                               
1060  continue                                                            
      ll=lcl                                                              
      lsn=lsn+1                                                           
      return                                                              
      end                                                                 
c                                                                         
code for sldl                                                             
      subroutine sldl (iln,lsn,lfw,llw)                                   
c--load list into store                                                   
c  iln  list type number                                                  
c  lsn  list serial number                                                
c  lfw  location of the first word of the list in store                   
c  llw  location of the last word of the list in store                    
c                                                                         
c--the  list is brought up from the bottom of the store,                  
c  ^lfw^and^llw^ are set on return                                        
c                                                                         
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
c
      call srlin (iln,lsn,li,lj,lk,ll)                                    
      lfw=nfl                                                             
      llw=lfw+ll-1                                                        
      nfl=llw+1
      call xsac(iln,lsn,lfw,llw)                                          
      call srdls(iln,lsn,lfw,l)                                           
      return
      end
c
code for srdls
      subroutine srdls(iln,lsn,lfw,lll)
c--read a list from the disc
c
c  iln  list type number
c  lsn  list serial number - set on return
c  doc  array to hold the list
c  lll  number of words to bring down - if zero the whole list
c       is brought down,and@ll@ is set to the number of words read
c
c--for lists with a  reamble block,only the preamble block is read,
c  and @lll@ is set negative on return
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
c
      call srlin (iln,lsn,li,lj,lk,ll)
      if(li) 1000,1000,1020
1000  continue
      call xwarni
      write(ncwu,1010) iln                                                
1010  format(///,16h no list of type,i5,8h  stored,/)                     
1015  continue                                                            
      call zerr                                                           
      stop 1111                                                           
1020  continue                                                            
      if(lk) 1040,1040,1030                                               
1030  continue                                                            
      ll=lk                                                               
1040  continue                                                            
      lll=ll                                                              
      nll=lll                                                             
      call ydwn(li,lfw,nll)
      il=store(lfw+1)                                                     
      if(il-iln)1061,1063,1061                                            
1061  continue                                                            
      call xwarni
      write(ncwu,1062)iln
1062  format(' requested list',i4,' has been corrupted')
      go to 1015                                                          
1063  continue                                                            
      if(lk) 1080,1080,1070                                               
1070  continue                                                            
      lll=-lll                                                            
1080  continue                                                            
      return                                                              
      end                                                                 
c                                                                         
code for sprtf                                                            
      subroutine sprtf                                                    
c--print the complete file index                                          
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xfili/lfirst,nwblo,lindex(240)
c
      dimension iq(10)
      data iq(1)/2h i/,iq(2)/2hnd/,iq(3)/2hex/,iq(4)/2h o/
      data iq(5)/2hf /,iq(6)/2hfi/,iq(7)/2hle/,iq(8)/2h l/                
      data iq(9)/2his/,iq(10)/2hts/                                       
c--                                                                       
      call xlc                                                            
1000  continue                                                            
      mln=lindex(2)                                                       
      il =lindex(5)                                                       
      write(ncwu,1010)(iq(i),i=1,10),lindex(3),lindex(6)                  
1010  format(/,6h print,10a2,' ( ',7haddress,i8 ,' , ',                   
     2 6hlength,i8,' )')
      call xprth                                                          
      i=il+1                                                              
      do 1030 j=1,mln                                                     
      if (lindex(i)) 1025,1025,1020                                       
1020  continue                                                            
      call xprtl(lindex(i),il)                                            
1025  continue                                                            
      i=i+il                                                              
1030  continue                                                            
      call xnxtf(ll)                                                      
      write(ncwu,1035) ll                                                 
1035  format(/,' next free location :',i8)                                
      call xline
      return
      end
c
code for xprth
      subroutine xprth
c--print the heading for an index entry
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      write(ncwu,1000)
1000  format(/,10h list type, 4x,
     2 10hserial no.,7x,
     3 7haddress,7x,
     4 15hpreamble length,4x,
     5 12htotal length,/)
      return
      end
c
code for xprtl
      subroutine xprtl (lid,il)
c--print an index entry which is given 'id'
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      dimension lid(*)
c--
      write(ncwu,1000)(lid(i),i=1,il)
1000  format(i7  ,i13  ,i11  ,2x,2hto,i8  ,i11  ,i18  )
      return
      end
c
code for kprth
      function kprth(iln)
c--print the list heading for current list 'ln'
c
c--return values of the function are as follows:
c  -1 no such list stored
c   0 non-blocked list stored
c   1 blocked list of this type stored
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      kprth=0
      call srlin(iln,lj,lk,ll,lm,ln)
      if(lk)1010,1010,1040
1010  continue
      call xwarni
      write (ncwu,1020) iln
1020  format(' no list',i4,' stored',/)
      kprth=-1
1030  continue
      return
1040  continue
      if(istat2.ne.0) write(ncwu,1050)iln,lj,lk,ln
1050  format(/,' print list',i4,
     1 '( serial no.',i4,', address',i8,' , length',i8,' )')
      if(lm) 1030,1030,1060
1060  continue
      kprth=1
      go to 1030
      end
c
code for kchf
      function kchf(nw,iarg,narg,nsarg)
c--check hash function
c
c  nw    number of words that form each separate argument
c  iarg  the array holding the arguments - each is 'nw' words
c        long in 'a2' format.
c  narg  the number of arguments.
c  nsarg the number of words to increment between the start of each
c        argument - may or may not be equal to 'nw'.
c
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)           
c                                                                         
      dimension iarg (*)
c--                                                                       
      i=-1                                                                
c--check if there is a new hash function ready                            
1005  continue                                                            
      if(ncd)1010,1010,1040                                               
c--find the next '#' function                                             
1010  continue                                                            
      i=i+1                                                               
      if(klnc(1)) 1020,1010,1040
c--end of file situation                                                  
1020  continue                                                            
      call xnotc(i)                                                       
      call xefer                                                          
      i=-1                                                                
      go to 1010                                                          
c--check the new function against the operation done here                 
1040  continue                                                            
      call xnotc(i)                                                       
      i=kcomp(nw,idoc,iarg,narg,nsarg)                                    
      if(i) 1050,1050,1080                                                
c--operation isn't performed by the calling subroutine                    
1050  continue                                                            
      kchf=-1                                                             
1070  continue                                                            
      return                                                              
c--new function is for the calling subroutine                             
1080  continue                                                            
      ncd=-1
      kchf=i
      go to 1070
      end
c
code for xnotc
      subroutine xnotc(j)
c--prints out the number of lines ignored (j)
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      if(j)1000,1000,1010
1000  continue
      return
1010  continue
      write(ncwu,1020) j
1020  format(/,i5,16h card(s) ignored,/)
      go to  1000
      end
c
code for klnc
      function klnc(jd)
c--this function loads the next card
c--
c--the value of klnc on return indicates the function on the next card
c--
c  -1  '##' indicating end of file, i.e. end of data marker
c   0  no special function on this card
c   1  '#' as the first character indicating useful alpha-numeric data
c
c--the symbol '#' is the only special symbol recognized
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      character*80 itemp
      character*1  ixx,izz,iyy,iprompt(3)
      data iprompt/'#','>',' '/
      data izz/'>'/,ixx/'#'/
      data ihh/1h%/,ikk/1h>/
c--
      if(jd.eq.0) jd=1
      if(jd.gt.3) jd=2
1030  continue
      iyy=iprompt(jd)
      if(jd.eq.1) then
      je=2
      image(1)=ih
      else
      je=1
      endif
      nt=80
c--read the next card
      call styb(iyy)
      if(itty) 1040,1035,1035
1035  continue
      je=1
1040  continue
      do i=je,nt
      image(i)=ib
      enddo
      read(ncru,1050,end=1130)(image(j),j=je,nt)
1050  format(80a1)
      write(itemp,1050)image
      call xcase(itemp)
      read(itemp,1050) image
      ni=ni+1
      nc=1
c--check the '#' function
      if(image(nc)-ih)	1062,1080,1062
1062  continue
      if(image(nc)-ihh) 1064,1080,1064
1064  continue
      if(image(nc)-ikk) 1060,1100,1060
1060  continue
      klnc=0
1070  continue
      nd=nc
      return
c--check for a comment card
1080  continue
      nc=2
      if(image(nc)-ib) 1090,1100,1090
c--check for end of card file
1090  continue
      if(image(nc)-ih) 1110,1130,1110
1100  continue
      call xpcci
      go to 1030
1110  continue
      if(kcsf(in)) 1130,1030,1120
1120  continue
      ncd=1
      klnc=1
      nc=2
c--commentata : altrimenti da errore se legge una direttiva seguente
c      nc=keq(nc,ib,2)
      call xpcci
      go to 1070
1130  continue
c--	write(ncwu,'(a)')' end of file encountered'
      klnc=-1
      go to 1070
      end
c
code for kcsf
      function kcsf(in)
c--process control statment format card
c
      common/jplat/jcfg
      character*60 ititle
      common/compd/ititle
      character*60 idfle,stfle
      common/cdisu/idfle,stfle
      common/funit/ncfu(9),nfon(9)
      character*60 ncwuf(9)
      common/wfile/ncwuf
      common/wunit/ncwun(9),nwon(9)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib(2),ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun,
     2 kkscr,llscr
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun,
     2 kkscr,llscr
      common /SWareRC/ SWRC, HOMEdir, CAOSdir
      character*80 SWRC, Inte, NewL, HOMEdir, CAOSdir
      character*60 driver,file(4)
      character*60 inpnam,outnam
      common/ioname/inpnam,outnam
      dimension itemp(20),itemp2(20)
      character*80 itemp1,carctr
      dimension ixo(14)
      character*40 itst
      character*1  iba
      character*4 ext
      character*25 ibuf
      data ibuf/'Output file opened at'/
      data itst/'the file name !'/
      data ext/' '/
      data ixo(1)/4hinpu/,ixo(2)/4hmoni/,ixo(3)/4htitl/
      data ixo(4)/4htemp/,ixo(5)/4habor/,ixo(6)/4houtp/
      data ixo(7)/4hfile/,ixo(8)/4hjob /,ixo(9)/4hstru/
      data ixo(10)/4hout /,ixo(11)/4hinp /,ixo(12)/4hopen/
      data ixo(13)/4hclos/,ixo(14)/4hwrit/
      data nxo/14/
c--
      iba=char(92)
      kcsf=0
      if(jrca(idoc,n)) 1050,1000,1050
1000  continue
      i=kcomp(1,idoc,ixo,nxo,1)
      if(i) 1010,1010,1030
1010  continue
      kcsf=1
1020  continue
      return
1030  continue
      call xpcci
      go to (1200,1300,1400
     1	    ,1500,1600,1700,1800,1400,1800
     2	    ,1700,1200,1900,1950,1750,1040),i
1040  continue
      stop 610
1050  continue
      call xpcci
      go to 1020
c
c--'#file' card     (or  %structure)
c**define structure binary file
1800  continue
c--allowed only if first directive
      if(idfle.eq.' ') goto 1801
      call xwarni
      write(itemp1,1805)image
1805  format(80a1)
      call shift(itemp1,len)
      write(ncwu,'(1x,a)')itemp1(1:len)
      write(ncwu,1810)
1810  format(' keyword not allowed in this contest !!!')
      goto 1020
1801  do 1802 k=1,20
      itemp(k)=ib(1)
1802  continue
      nc=keq(nc,ib,2)
      nc=kne(nc,ib,2)                                                     
      n=80-nc+1                                                           
      call scomp(image(nc),itemp,n)
      itemp1=' '
      write(itemp1,1005) itemp
1005  format(20a4)
      call xpathx(itemp1,carctr,1)
      key=-1
      if(iflstd(carctr,key)) 1040,1820,1820
1820  continue
c      write(ncwu,1821) idfle
1821  format(' User file = ',a)
c      write(ncwu,1822) ititle
1822  format(1x,a,/)
      goto 1020
c
c--'#input' card
c**redefine input unit file (se nessun nome e' dato, ritorna la tastiera)
1200  continue
      if(ncru.eq.55) close(ncru)
      do k=1,20
      itemp(k)=ib(1)
      enddo
      nc=keq(nc,ib,2)
      nc=kne(nc,ib,2)
      if(nc.gt.0) then
       n=80-nc+1
       call scomp(image(nc),itemp,n)
       itemp1=' '
       write(itemp1,1005) itemp
       itty=0
       call xpathx(itemp1,carctr,2)
       file(3)=carctr
       ncru=55
       nlen=80
       if(jopen(ncru,carctr,nlen,ier)) 1210,1020,1210
      else
       file(3)=' '
       itty=-1
       ncru=5
       go to 1020
      endif
c--error
1210  write(ncwu,1211) ier
1211  format(' kcsf error ! (',i4,')')
      call xerr
      go to 1020
c
c--'#output' card
c**redefine output unit file (se nessun nome e' dato, ritorna al video)
1700  continue
c      if(ncwu.eq.66) close(ncwu)
      do k=1,20
      itemp(k)=ib(1)
      enddo
      nc=keq(nc,ib,2)
      nc=kne(nc,ib,2)
      if(nc.gt.0) then
       n=80-nc+1
       call scomp(image(nc),itemp,n)
       itemp1=' '
       write(itemp1,1005) itemp
       call shift(itemp1,ncons)
c--check in the list of output file(s) previously opened
       do k=1,9
	 if(ncwuf(k).eq.' ') then
	  ncwuf(k)=itemp1
	  nwon(k)=1
	  ncwu=ncwun(k)
	  call xpathx(itemp1,carctr,3)
	  if(iopen(ncwu,carctr,ier)) 1210,1705,1210
1705	  continue
	  file(4)=carctr
	  goto 1704
	 else
	  outnam=ncwuf(k)
        call shift(outnam,ncons1)
	  if(ncons.gt.ncons1) ncons=ncons1
	  do i=1,ncons
	   if(itemp1(i:i).ne.outnam(i:i)) goto 1707
	  enddo
	  nwon(k)=1
	  ncwu=ncwun(k)
	  file(4)=outnam
	  goto 1704
	 endif
1707	 continue
       enddo
       write(ncwu,'(a)') ' Warning! Too much output file opened!'
       call xerr
       goto 1020
      else
       ncwu=6
       file(4)=' '
      endif
1704  continue
      call shift(file(4),lenp)
      write(ncwu,1710) file(4)(1:lenp)
1710  format(' Output file is now : **** ',a,' ****')
      call prtdate(ibuf)
      call shift(idfle,lenp)
      write(ncwu,1821) idfle(1:lenp)
      call shift(ititle,lenp)
      write(ncwu,1706) ititle(1:lenp)
1706  format(1x,a,/)
      goto 1020
c
c--'#open' card
c**open a I/O file
1900  continue
      do k=1,20
      itemp(k)=ib(1)
      enddo
      jop=kredi(in)
      if(jop.le.0.or.jop.gt.9) then
       write(ncwu,'(a,i4)')' Warning! Wrong I/O file unit:',jop
       call xerr
       go to 1020
      else
       n=nfon(jop)
       if(n.ne.0) then
	write(ncwu,'(a,i4)')' Warning! I/O file already open:',jop
	call xerr
	go to 1020
       endif
       nfon(jop)=1
       ncfuc=ncfu(jop)
       nc=keq(nc,ib,2)
       nc=kne(nc,ib,2)
       if(nc.gt.0) then
	n=80-nc+1
	call scomp(image(nc),itemp,n)
	itemp1=' '
	write(itemp1,1005) itemp
	call xpathx(itemp1,carctr,3)
	if(iopen(ncfuc,carctr,ier)) 1210,1905,1210
1905	continue
       else
	write(ncwu,'(a)')' Warning! I/O file name was not given'
	call xerr
	go to 1020
       endif
       call shift(carctr,lenp)
       write(ncwu,1910) jop,carctr(1:lenp)
1910   format(' I/O file(',i1,') is : **** ',a,' ****')
       goto 1020
      endif
      goto 1020
c
c--'#close' card
c**close a I/O file
1950  continue
c--read in numeric
      nca=nc
      jop=kredi(in)
      if(jop.gt.0) then
       if(jop.gt.9) then
	write(ncwu,'(a,i4)')' Warning! Wrong I/O file unit:',jop
	call xerr
	go to 1020
       else
	n=nfon(jop)
	if(n.eq.0) then
	 write(ncwu,'(a,i4)')' Warning! I/O file was not open:',jop
	 call xerr
	 go to 1020
	endif
	nfon(jop)=0
	ncfuc=ncfu(jop)
	close(ncfuc)
	write(ncwu,1960) jop
1960	format(' I/O file number unit',i4,' is closed')
	goto 1020
       endif
      else
c--read alpha-numeric
       nc=nca
       nc=keq(nc,ib,2)
       nc=kne(nc,ib,2)
       if(nc.gt.0) then
	n=80-nc+1
	call scomp(image(nc),itemp,n)
	itemp1=' '
	write(itemp1,1005) itemp
      call shift(itemp1,ncons)
c--check against output file(s) previously opened
	do k=1,9
	 if(ncwuf(k).ne.' ') then
	  outnam=ncwuf(k)
        call shift(outnam,ncons1)
	  if(ncons.gt.ncons1) ncons=ncons1
	  do i=1,ncons
	   if(itemp1(i:i).ne.outnam(i:i)) goto 1974
	  enddo
	  nwon(k)=0
	  ncwuc=ncwun(k)
	  call shift(outnam,lenp)
	  write(ncwuc,1970) outnam(1:lenp)
1970	  format(' Output file is now closed : **** ',a,' ****')
	  close(ncwuc)
	  if(ncwuc.eq.ncwu)then
	    ncwu=6
	    file(4)=' '
	    call shift(file(4),lenp)
	    write(ncwu,1710) file(4)(1:lenp)
	    call prtdate(ibuf)
	    call shift(idfle,lenp)
	    write(ncwu,1821) idfle(1:lenp)
	    call shift(ititle,lenp)
	    write(ncwu,1706) ititle(1:lenp)
	  endif
	  goto 1020
	 endif
1974	 continue
	enddo
	write(ncwu,'(a,a)')' Warning! Wrong file name :',outnam
	call xerr
	goto 1020
       else
	write(ncwu,'(a)')' Warning! No output file name was given'
	call xerr
	goto 1020
       endif
      endif
      goto 1020
c
c--'#write' card
c**write a record on a I/O file
1750  continue
      do k=1,20
      itemp(k)=ib(1)
      enddo
      jop=kredi(in)
      if(jop.le.0.or.jop.gt.9) then
       write(ncwu,'(a,i4)')' Warning! Wrong I/O file unit:',jop
       call xerr
       go to 1020
      else
       n=nfon(jop)
       if(n.eq.0) then
	write(ncwu,'(a,i4)')' Warning! I/O file was not open:',jop
	call xerr
	go to 1020
       endif
       ncfuc=ncfu(jop)
       nc=keq(nc,ib,2)
       nc=kne(nc,ib,2)
       itemp1=' '
       lenp=1
       if(nc.gt.0) then
	 n=80-nc+1
	 write(itemp1,'(80a1)')(image(i),i=nc,80)
c	 call scomp(image(nc),itemp,n)
c	 write(itemp1,1005) (itemp(i),i=1,n)
	 call shift(itemp1,lenp)
       endif
       write(ncfuc,'(a)') itemp1(1:lenp)
       goto 1020
      endif
      goto 1020
c
c--'#monitor' card
1300  continue
      istat2=kredi(in)
      go to 1020
c
c--'#title' card   (or '%job ')
1400  continue
      call srdn
      go to 1020
c
c--'#temporary' card
1500  continue
	itype=0
	ext=' '
	call rdfile(itst,ext,itemp1,iscr,itype,ier)
	if(ier.ne.0) goto 1600
      write(ncwu,1515) iscr
1515  format(' temporary file : ',a,/)
      go to 1020
c
c--'#abort' card
1600  continue
      iabort=1
      kcsf=-1
      goto 1020
      end
c
code for idefa
      function idefa(in)
c--check the hash character after the directive
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib(2),ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)  
c--                                                                       
      idefa=0                                                             
      nc=keq(nc,ib,2)
      nd=kne(nc,ib,2)
      if(nd) 1010,1010,1020                                               
1010  continue                                                            
      return                                                              
1020  continue
      if(image(nd)-ih) 1010,1030,1010                                     
1030  continue
      idefa=1
      return
      end
c
code for kcomp
      function kcomp(nw,itest,iarg,narg,nsarg)
c--standard comparision routine
c
c  nw     number of separate words to be compared
c  itest  vector holding the word(s) to be compared
c  iarg   vector holding the wrods against which the comparision is to
c         be made
c  narg   number of standard words to compare against
c  nsarg  the step beteen successive comparision words
c
c-- on return kcomp holds the position of the find or else -1
c
c--
      dimension itest(*),iarg(*)
      i=1
      j=1
1000  continue
      if(narg-i)1010,1030,1030
1010  continue
      kcomp=-1
1020  continue
      return
1030  continue
      k=1
      l=j
1040  continue
      if(itest(k)-iarg(l)) 1080,1050,1080
1050  continue
      if(nw-k)1060,1060,1070
1060  continue
      kcomp=i
      go to 1020
1070  continue
      k=k+1
      l=l+1
      go to 1040
1080  continue
      i=i+1
      j=j+nsarg
      go to 1000
      end
c
code for csprt
      subroutine csprt(iarg,narg)
c--print a vector
c
c  iarg   vector holding the words
c  narg   number of standard words
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension iarg(*)
      do i=1,narg
      write(ncwu,1050) i,iarg(i)
1050  format(1x,i5,' : ',a4)
      end do
      return
      end
c
code for xline
      subroutine xline
c--insert blank line in the output stream after each list
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      write(ncwu,1000)
1000  format(1h )
      return
      end
c
code for kintk
      function kintk(a)
c--
      if(a) 1000,1010,1010
1000  continue
      kintk=int(a-0.5)
      go to 1020
1010  continue
      kintk=int(a+0.5)
1020  continue
      return
      end
c
code for lint
      function lint(n)
      common /xdata/ store(1000000)
c--
      a=store(n)
      lint=kintk(a)
      return
      end
c
code for stim2
      subroutine stim2(nn)
c--this entry calculates and prints the time taken to do an operation
c  n  identifies the operation
c--
      common/xtime/it(20),itu(20)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      i=nn*4+1
c**machine specific
      call xtimx(ielaps,icpu)
      it ( 19)=ielaps/3600
      itu( 19)=icpu  /3600000
      irest1=mod(ielaps,3600)
      irest2=mod(icpu  ,3600000)
      it ( 18)=irest1/60
      itu( 18)=irest2/60000
      it ( 17)=mod(irest1,60)
      itu( 17)=mod(irest2,60000)
      nh =it (19)-it (i+3)
      nhu=itu(19)-itu(i+3)
      nm =it (18)-it (i+2)
      nmu=itu(18)-itu(i+2)
      if(nm) 1040,1050,1050
1040  continue
      nh=nh-1
      nm=60+nm
1050  continue
      if(nmu) 1055,1060,1060
1055  continue
      nhu=nhu-1
      nmu=60+nmu
1060  continue
      ns =it (17)-it (i+1)
      nsu=itu(17)-itu(i+1)
      if(ns) 1070,1080,1080
1070  continue
      if(nm) 1075,1075,1076
1075  continue
      nh=nh-1
      nm=60
1076  continue
      nm=nm-1
      ns=60+ns
1080  continue
      if(nsu) 1085,1100,1100
1085  continue
      if(nmu) 1090,1090,1095
1090  continue
      nhu=nhu-1
      nmu=60
1095  continue
      nmu=nmu-1
      nsu=60000+nsu
1100  continue
      fs=float(nsu)/1000.0
      write(ncwu,1010) nhu,nmu,fs
1010  format(14h CPU time     ,i2.2,8h hour(s),2x,i2.2,
     2 7h min(s),2x,f5.2,7h sec(s) )
      write(ncwu,1000) nh ,nm,ns
1000  format(	14h Elapsed time ,i2.2,8h hour(s),2x,i2.2,
     2 7h min(s),i4,3x,7h sec(s)  )
      return
      end
c
code for stim1
      subroutine stim1(n)
c--initiate the timing of a given operation
c
c  n  the number that identifies this operation (1-2)
c     entry with n=0 is reserved for overall timing
c
      common/xtime/it(20),itu(20)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      i=n*4+1
c**machine specific
      call xtimx(ielaps,icpu)
      it (i+3)=ielaps/3600
      itu(i+3)=icpu  /3600000
      irest1=mod(ielaps,3600)
      irest2=mod(icpu  ,3600000)
      it (i+2)=irest1/60
      itu(i+2)=irest2/60000
      it (i+1)=mod(irest1,60)
      itu(i+1)=mod(irest2,60000)
      return
      end
c
code for fiprt
      subroutine fiprt(ncmu,ncwu)
c--print a ascii dics file
c
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint,namh
      character*80 ivet
c--
1000  continue
      ivet=' '
      read(ncmu,1020,iostat=ier,err=1300,end=1300) ivet
1020  format(a)
      call shift(ivet,jlen)
c      jlen=Lung(ivet)
      if(jlen.eq.0) goto 1000
      write(ncwu,1030) ivet(1:jlen)
1030  format(1x,a)
      go to 1000
1300  continue
      return
      end
c
code for stya
      subroutine stya(ia)
c--write the vector 'ia' on teletype
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*(*) ia
c--
      if(itty)   1000,1010,1010
1000  continue
      write(intty,1001) ia
1001  format(1x,a)
1010  continue
      return
      end
c
code for styb
      subroutine styb(ia)
c--write the character on teletype
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*(*) ia
c
      if(itty) 1000,1010,1010
1000  continue
      write(intty,1001) ia
1001  format(1x,a,$)
1010  continue
      return
      end
c
code for sty
      subroutine sty(ia)
c--write the vector 'ia' on teletype
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*(*) ia
c--
      if(itty) 1000,1010,1010
1000  continue
      write(intty,1001) ia
1001  format(' please enter ',a)
1010  continue
      return
      end
c
code for rdfile
      subroutine rdfile(ia,ext,stfle,idfle,itype,ier)
c--read a file name from standard input
c  ia	 = prompt string
c  ext	 = extension to be added
c  stfle = file name without extension
c  idfle = file name inclunding path
c  itype = 0  generic file
c	   1  binary file
c	   2  input file
c	   3  output file
c  ier	 = 0  OK
c	   -1 # caracter found
c	   1  no input file name
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*(*) ia,ext,stfle,idfle
      character*60 filex
      character*1  ixx
      data ixx/'>'/ 
c--
	ier=0
	call sty(ia)
	call styb(ixx)
	filex=' '
	read(ncru,1010) filex
1010	format(a)
	call shift(filex,l)
c--	l=len(filex)
	if(l.eq.0.or.filex.eq.' ') then
	 ier=1
	 return
	endif
	do i=1,l
	 if(filex(i:i).eq.'#') then
	  ier=-1
	  return
	 endif
	enddo
	if(ext(1:1).eq.'.') then
	 call setext(filex,ext,stfle)
	endif
	call xpathx(filex,idfle,itype)
	return
	end
c
code for xpcci
      subroutine xpcci
c--print the current card image
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      character*80 ibuf
c--
      write(ibuf,2040)(image(i),i=1,nt)
2040  format(80a1)
      call prtime(ni,ibuf)
      return
      end
c
code for xwarni
      subroutine xwarni
c--print warning message
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      if(itty) 1000,1010,1010
1000  continue
      write(intty,1001)
1001  format(' Warning !!!')
1010  continue
      return
      end
c
code for xendx
      subroutine xendx
c--exit routine
c
      character*60 ititle
      common/compd/ititle
      common/xnclu/ncmu,nctu,ncau,ncsu,nclg,nccf
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xdisu/ncdfu ,ndfle,irecx,ldaf,nbytes
      character*18 ibuf
      data ibuf/'Job terminated at'/
c
      call xnxtf(l)
      in=1
      call supfi(in)
      close(ncdfu,iostat=ier,err=9000)
      write(ncwu,1000)
1000  format(/,' Print the log file:',/) 
      rewind nclg
      call fiprt(nclg,ncwu)
      close(nclg)
      call xline
      call stim2(0)
      call prtdate(ibuf)
      stop ' Caos terminated'
9000  continue
      call xwarni
      write(ncwu,9010) ier
9010  format(' xout: ',i5,' error')
      call zerr
      stop 100
      end
c
code for xerr
      subroutine xerr
c--link for errors which require a special print routine
c
      common/xunit/ ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      if(itty.ne.0) go to 1020
      call zerr
      stop 7777
1020  continue
      return
      end
c
code for zerr
      subroutine zerr
c--job ends in error
c
      common/xnclu/ncmu,nctu,ncau,ncsu,nclg,nccf
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      common/xunit/ ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      write(ncwu,1000)
1000  format(/,' Print the log file:',/)
      rewind nclg
      call fiprt(nclg,ncwu)
      close(nclg)
      write(ncwu,1020)
1020  format(/,' Job ends in error')
      stop 'Caos aborted'
c--dummy return
c      return
      end
c
code for xunkw
      subroutine xunkw
c--print message for unknown directive
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      call xwarni
      write(ncwu,1000)
1000  format(    29h unknown directive on card  *  )
      call xpcci
c--	call xerr
      return
      end
c
code for xefer
      subroutine xefer
c--attempted read past real or simulated end of file
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      call xwarni
      write(ncwu,1000)
1000  format(42h attempted read past end of file on card : ,/)
      call xpcci
      call xerr
      return
      end
c
code for xmhf
      subroutine xmhf
c--misplaced '#directive' sequence
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
c--
      call xwarni
      write(ncwu,1000)ih,(image(i),i=1,nt)
1000  format(13h unexpected ',a1,18hdirective' card : ,80a1,/)
      call xerr
      return
      end
c
code for xildr
      subroutine xildr
c--illegal directive card - syntax error
c
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      i=nc
      if(i) 1000,1000,1010
1000  continue
      i=nt+1
1010  continue
      call xwarni
      write(ncwu,2070) ih,i
2070  format(18h format error on ',a1,15hdirective' card,
     2 16h at about column,i4,/)
      call xerr
      return
      end
c
code for xspch
      subroutine xspch
c--print out a message for a spurious character
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      call xpcci
      call xwarni
      write(ncwu,1020)
1020  format(30h spurious character (marked *),/)
      return
      end
c
code for xsac
      subroutine xsac(iln,lsn,lfw,llw)
c--storage allocation control - this subroutine also
c  checks that the store limits have not been exceeded
c
c  iln list type that is being used for this data type
c  lsn  list serial number
c  lfw  first word used in 'store'
c  llw  last word used in 'store'
c
c--
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xsae/ ncl,lis(4,39)
c--
      if(ncl) 980,980,950
950   continue
      do 970 i=1,ncl
      if(iln-lis(1,i)) 970,960,970
960   continue
      j=i
      go to 990
970   continue
980   continue
      ncl=ncl+1
      j=ncl
990   continue
      lis(1,j)=iln
      lis(2,j)=lsn
      lis(3,j)=lfw
      lis(4,j)=llw
      if(nfl+5-lfl) 1000,1000,1010
1000  continue
      if(istat2.le.2) return
      call xpas
      return
1010  continue
      call xwarni
      write(ncwu,1020)iln
1020  format(32h1***store overflow*** (list type,i5,1h))
      call xpas
      call zerr
      stop
      end
c
code for xcsae
      subroutine xcsae
c--clear storage allocation entries
c
      common/xsae/ ncl,lis(4,39)
      ncl=0
      return
      end
c
code for ksfls
      function ksfls(in,im)
c--extract the information of type 'im' for data type 'in'
c from the store allocation entries
c
c  in  the data type
c  im  defines the position in 'is' e.g. is(im,i)
c
c--
      common/xsae/ ncl,lis(4,39)
c--
      ksfls=0
      if(ncl)1020,1020,990
990   continue
      do 1010 i=1,ncl
      if(in-lis(im,i))1010,1000,1010
1000  continue
      ksfls=i
      go to 1020
1010  continue
1020  continue
      return                                                              
      end                                                                 
c                                                                         
code for xpas                                                             
      subroutine xpas                                                     
c--print allocated store                                                  
c                                                                         
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xsae/ ncl,lis(4,39)
c--
c--check if any entries are waiting to be printed
      if(ncl) 1035,1035,990
990   continue
      write(ncwu,1000)
1000  format(///,18h allocated store :,//,5x,
     2 9hlist type,4x,10hserial no.,9x,7haddress,9x,6hlength,/)
      do 1030 i=1,ncl
      l=lis(4,i)-lis(3,i)+1
      write(ncwu,1020)(lis(k,i),k=1,4),l
1020  format(    2i13,i14,4h  to,i7,i10)
1030  continue
1035  continue
      l=lfl-nfl+1
      write(ncwu,1040)nfl,lfl,l
1040  format(//,19h free location(s) : ,i7,4h to ,i7,
     2 2h, ,i7,9h word(s) )
      return
      end
c
code for jrca
      function jrca(ja,n)
c--read an holerith string terminated by a blank or comma
c  into the array 'ia' and put the number of characters read
c  into 'n'
c
c--the input variables are :
c
c  ia the array to hold the character string (a2 format)
c  n  the number of characters read  -  number of words used
c     is equal to (n+1)/2
c
c--
      common/xchar/id,ie,ibb(2),ia,ih,numb(10),iplus, inus,ipoint,namh
      dimension ja(*)
c--
      j=jrcx(ja,n,ibb,2)
      jrca=j
      return
      end
c
code for jrcx
      function jrcx(ja,n,j,k)
c--read a holerith character string, terminated by one of the
c  characters contained into yhe vector 'j', putting the result
c  into 'ia' and the number of characters into 'n'
c
c-- jrcx is set as follows on return :
c
c  -1  character string not found
c   0  all okay
c
c--input values are :
c
c  ja the array to hold the character string (a2 format)
c  n  the number of characters read  -  number of words used              
c     is equal to (n+1)/2
c  j  the vector containing the characters that is to terminate
c     the string (a1 format)
c  k  number of characters in 'j'
c
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      dimension ja(*)
      dimension j(*)
c
c--set up the initial constats
      i=0
      jn=0
      jrcx=0
      nd=kne(nc,j,k)
      if(nd) 1010,1010,1020
1010  continue
      jrcx=-1
      go to 1100
1020  continue
c--determine the length of the character string
      nc=keq(nd,j,k)
      if(nc) 1030,1030,1040
1030  continue
      nc=81
1040  continue
      n=nc-nd
      call scomp(image(nd),ja,n)
1100  continue
      return
      end
c
code for knum
      function knum(in)
c--fetch the holerith equivalent of (in-1)
c
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint,namh
c
      knum=numb(in)
      return
      end
c
code for kneb
      function kneb(nc,nd,n)
c--search a card for the character not of type 'nd'
c
c  nc  character position at which to start
c  nd  the vector containing the characters which the current
c      character must not be
c  n   number of characters in 'nd'
c
c--kneb returns set to the position of the first character not
c  equal to 'nd', or else to -1.
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcard/nch,image(80),idm(3),nt,na(3),ncd,idoc(20),irs(4)
      dimension nd(*)
c--
      i=nc
      kneb=nc
      if(i) 1000,1000,1001
1001  if(i-1) 1000,1002,1002
1002  continue
      do 1004 l=1,n
      if(image(i)-nd(l)) 1004,1006,1004
1004  continue
      go to 1005
1006  continue
      i=i-1
      go to 1001
1005  kneb=i
      return
1000  continue
      kneb=-1
      return
      end
c
code for kne
      function kne(nc,nd,n)
c--search a card for the character not of type 'nd'
c
c  nc  character position at which to start
c  nd  the vector containing the characters which the current
c      character must not be
c  n   number of characters in 'nd'
c
c--kne returns set to the position of the first character not
c  equal to 'nd', or else to -1.
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcard/nch,image(80),idm(3),nt,na(3),ncd,idoc(20),irs(4)
      dimension nd(*)
c--
      i=nc
      kne=-1
      if(i) 1000,1000,1001
1001  if(i-nt-1) 1002,1000,1000
1002  continue
      do 1004 l=1,n
      if(image(i)-nd(l)) 1004,1006,1004
1004  continue
      go to 1005
1006  continue
      i=i+1
      go to 1001
1005  kne=i
1000  continue
      return
      end
c
code for keq
      function keq(nc,nd,n)
c--find the next character on a card
c
c  nc  character position at which to start
c  nd  the vector containing the characters to search for
c  n   number of characters in 'nd'
c
c--keq is set to the character position , or -1 if the character
c  can not be found
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcard/nch,image(80),idm(3),nt,na(3),ncd,idoc(20),irs(4)
      dimension nd(n)
c--
      i=nc
      keq=-1
      if(i) 1000,1000,1001
1001  if(i-nt-1) 1002,1000,1000
1002  continue
      do 1004 l=1,n
      if(image(i)-nd(l)) 1004,1005,1004
1004  continue
      i=i+1
      go to 1001
1005  keq=i
1000  continue
      return
      end
c
code for kredi
      function kredi(in)
c--read an integer number, terminated by any non-numeric character
c
c--on return, 'kredi' is assigned the value of the number
c  read.
c
c--processing of the number begins at the first non-blank character
c  on the current card (no card changes are performed by this routine),
c  and terminates at the next non - numeric character.
c
c--this means that a spurious character will always return
c  a value of zero to @kreadi@ unless the calling
c  routine moves the character pointer beyond the offending
c  spurious character.
c  (the same applies when the end of the card has been found)
c
c-- obviously this routine is limited,and is only really
c  designed to find control variables on @=directive@cards.
c
c--if the character that causes the  termination of a number
c  is @.@, then the @.@ and any other numeric characters
c  are skipped before the routine exists.
c  (i.e. floating pint numbers are truncated, but do not
c   cause an error).
c
c--
      common/xchar/id(4),ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
c
c--search for the first blank character
      nc=keq(nc,id,4)
      kredi=jredi(in)
      return
      end
c
code for jredi
      function jredi(in)
c--like kredi function
c
c--no searching for the first blank character
c
c--
      common/xchar/id(4),ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
c--set up the initial constants
      i=0
      j=1
c--search for the first non-blank character
      nc=kne(nc,id,4)
      if(nc) 1010,1010,1020
c--return sequence
1010  continue
      jredi=i*j
      return
c--check if first character is @+@ or @-@
1020  continue
      if(image(nc)-iplus)1030,1050,1030
1030  continue
      if(image(nc)- inus)1060,1040,1060
1040  continue
      j=-j
1050  continue
      nc=nc+1
      if(nc-nt-1) 1060,1010,1010
1060  continue
      do 1080 k=1,10
      if(image(nc)-numb(k)) 1080,1070,1080
1070  continue
      i=i*10+k-1
      go to 1050
1080  continue
c--remove any decimal points and numbers thereafter
      if(image(nc)-ipoint)1010,1090,1010
1090  continue
      nc=nc+1
      if(nc-nt-1) 1100,1010,1010
1100  continue
      do 1110 k=1,10
      if(image(nc)-numb(k)) 1110,1090,1110
1110  continue
      go to 1010
      end
c
code for kredni
      function kredni(istore,non)
c--read integer numbers
c
c--kreadni is set as follows on return :
c
c  -1  hash function found
c   0  numbers read    correctly
c   1  spurious character found
c
c--input values are :
c
c  istore the array in to which the numbers should go
c  non	  the number of numbers to read
c
c
c--this routine does not use fortran input processor and is thus
c  able to recover any data errors.
c
c--a number is terminated by one or more spaces,or the end of a card.
c
c--
      common/xchar/id,ie,ib(2),ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      dimension istore(*)
c--
      kredni=0
      j=non
      k=1
8000  continue
      if(j) 8120,8120,8010
c--search for non-black characters
8010  continue
      nc=kne(nc,ib,2)
      if(nc) 8020,8020,8090
c--card change
8020  continue
      if(klnc(2)) 8030,8025,8030
8025  continue
c      call xpcci
      go to 8010
c--directive or end of file on this card
8030  continue
      kredni=-1
      go to 8120
c--read a number
8090  continue
      istore(k)=jredi(in)
      k=k+1
      j=j-1
      go to 8000
8120  continue
      return
      end
c
code for jredf
      function jredf(a,n)
c--read n floating point number
c
c--jredf is set as follows on return :
c
c  -1  hash function found or spurious character found
c   0  all the numbers read correctly
c   1  not all the number have been read
c
c--
      common/xchar/id,ie,ib(2),ia,ih,numb(10),iplus,inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
c--
      dimension a(n)
      do i=1,n
      a(i)=0.0
      enddo
      jredf=0
      do 1030 i=1,n
      nc=kne(nc,ib,2)
      if(nc) 1010,1010,1020
1010  continue
      jredf=1
      return
1020  continue
      if(kredf(a(i),1)) 1040,1030,1010
1030  continue
      return
1040  continue
      jredf=-1
      return
      end
c
code for kredf
      function kredf(store,non)
c--read floating point numbers
c
c--kreadf is set as follows on return :
c
c  -1  hash function found
c   0  numbers read    correctly
c   1  spurious character found
c
c--input values are :
c
c  store the array in to which the numbers should go
c  non   the number of numbers to read
c
c
c--this routine does not use fortran input processor and is thus
c  able to recover any data errors.
c
c--a number is terminated by one or more spaces,or the end of a card.
c
c--
      common/xchar/id,ie,ib(2),ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      dimension store(non)
c--
      kredf=0
      j=non
      k=1
8000  continue
      if(j) 8120,8120,8010
c--search for non-black characters
8010  continue
      nc=kne(nc,ib,2)
      if(nc) 8020,8020,8090
c--card change
8020  continue
      if(klnc(2)) 8030,8025,8030
8025  continue
      call xpcci
      go to 8010
c--directive or end of file on this card
8030  continue
      kredf=-1
      go to 8120
c--read a number
8090  continue
      if(kinpt(store(k))) 8100,8110,8100
c--spurious character found
8100  continue
c--	call xspch
      nc=keq(nc,ib,2)
      kredf=1
      go to 8120
8110  continue
      k=k+1
      j=j-1
      go to 8000
8120  continue
      return
      end
c
code for kinpt
      function kinpt(a)
c--read a number from a card
c
c  the numeric value is put in 'a'
c
c--error functions are indicated by the value of kinput on return
c
c  -1  first character does not indicate a number in this position
c   0  number read correctly
c   1  spurious character found after the first character read
c
c--on entry, the card character pointer ('nc') is assumed to be
c  pointing at first character of the number - i.e.  this
c  routine does not skip over blank spaces at the start.
c
c--a number is terminated by one or more spaces or the end  of a card
c
c--
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
c--
c--set up the initial constants
      j=nc
      t=0.
      s=1.
      r=10.
      q=1.
      p=1.
c--check the first character to be read
      if(image(nc)-iplus)1000,1050,1000
1000  continue
      if(image(nc)- inus) 1020,1010,1020
1010  continue
      s=-1.
      go to 1050
1020  continue
      if (image(nc)-ipoint)1100,1040,1100
c--check if this is  the first '.' found
1030  continue
      if(p-0.5) 1130,1130,1040
c--reset for reading after the '.'
1040  continue
      r=1.
      q=0.1
      p=0.1
1050  continue
      nc=nc+1
c--check if this is end of card
      if(nc-nt-1) 1060,1070,1070
c--check if this is the end of the number - ' '
1060  continue
      if(image(nc)-ib    ) 1090,1070,1090
1070  continue
      kinpt=0
1075  continue
      a=t*s
      return
1090  continue
      if(image(nc)-ipoint)1100,1030,1100
c--find the numeric equivalent of the character and add in
1100  continue
      do 1120  i=1,10
      if(image(nc)-numb(i)) 1120,1110,1120
1110  continue
      t=t*r+float(i-1)*q
      q=q*p
      go to 1050
1120  continue
c--check if an error occurs on the first character read
      if(j-nc) 1130,1140,1130
1130  continue
      kinpt=-1
      go to 1075
1140  continue
      kinpt=1
      go to 1075
      end
c
code for xlabel
      subroutine xlabel(ja,a,ivet)
c--form the atom label
c
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint,namh
      dimension ivet(*),ja(*)
      dimension itemp(80)
      do i=1,4
      ivet(i)=ib
      enddo
      jb=1
      jc=int(a)
      call sa21(jb,ja,itemp)
      call sned(jb,jc,itemp)
      jb=jb-1
      call scomp(itemp,ivet,jb)
      return
      end
c
code for fr4to2
      subroutine fr4to2(ivet)
c--change the atom label  format:
c  from a4 to a2
c
      dimension ivet(*)
      character*8 itemp
      write(itemp,'(2a4)') (ivet(i),i=1,2)
      read(itemp,'(4a2)') (ivet(i),i=1,4)
      return
      end
c
code for fr2to4
      subroutine fr2to4(ivet)
c--change the atom label  format:
c  from a2 to a4
c
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint,namh
      dimension ivet(*)
      character*8 itemp
      write(itemp,'(4a2)') (ivet(i),i=1,4)
      read(itemp,'(2a4)') (ivet(i),i=1,2)
      ivet(3)=ib
      ivet(4)=ib
      return
      end
c
code for sa21
      subroutine sa21(j,ind,ivet)
c--
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
c--
      dimension ivet(*),ind(*)
c--
      call scar(ind,ivet(j),1)
      do i=1,nch
      if(ivet(j)-ib) 1010,2000,1010
1010  continue
      j=j+1
      enddo
2000  continue
      return
      end
c
code for sned                                                             
      subroutine sned(j,iarg,ivet)                                        
c--transform integer number to alphanumeric characters                    
c                                                                         
c  the number will be enclosed by brackets                                
c  j      first address in ivet                                           
c  iarg   integer number                                                  
c  ivet   vector for printing                                             
c                                                                         
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint,namh
      dimension ivet(*)
c--                                                                       
      if(iarg) 1105,1300,1105                                             
1105  continue                                                            
      ix=iarg                                                             
      m=0                                                                 
      nmx=5                                                               
      ivet(j)=id                                                          
      j=j+1                                                               
      do 1200 i=1,nmx                                                     
      i1=nmx-i                                                            
      i2=ix/(10**i1)                                                      
      if(i2) 1000,1000,1100                                               
1000  continue                                                            
      if(m) 1200,1200,1110                                                
1100  continue                                                            
      m=1                                                                 
1110  continue                                                            
      n=i2+1                                                              
      ivet(j)=numb(n)                                                     
      j=j+1                                                               
      ix=ix-i2*(10**i1)                                                   
1200  continue                                                            
      ivet(j)=ie                                                          
      j=j+1                                                               
1300  continue                                                            
      return                                                              
      end                                                                 
c                                                                         
code for salf                                                             
      subroutine salf(j,iarg,ivet)                                        
c--trasform integer number to alphanumeric characters                     
c  j  last address in ivet                                                
c  iarg  integer  number                                                  
c  ivet  vector for printing                                              
c                                                                         
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint,namh
      dimension ivet(*)
c                                                                         
      iar=iabs(iarg)                                                      
 1000 continue                                                            
      iar1=iar                                                            
      iar=iar/10                                                          
      i=iar1-iar*10+1                                                     
      ivet(j)=numb(i)                                                     
      j=j-1                                                               
      if(iar)  1010,1010,1000                                             
 1010 continue                                                            
      if(iarg)  1020,1030,1030                                            
 1020 continue                                                            
      ivet(j)= inus                                                       
      j=j-1                                                               
 1030 continue
      return
      end
c
code for scomp
      subroutine scomp(ja,jb,i)
c--compress four (ex two) characters in one word
c
c  ja  vector holding the characters
c  jb  vector holding the words
c  i   number of characters to compress
c
c--
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      character*80  ibuf
      dimension ja(*),jb(*)
c
c--clear buffer
      ibuf=' '
      write(ibuf,1000)(ja(j),j=1,i)
1000  format(80a1)
      i1=(i+nch-1)/nch
      read(ibuf,1010)(jb(j),j=1,i1)
1010  format(20a4)
      return
      end
c
code for scar
      subroutine scar(ja,jb,i)
c--devide one word into two words
c
c  ja  vector holding the words
c  jb  vector holding the characters
c  i   number of words to devide
c
c--
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      character*80  ibuf
      dimension ja(*),jb(*)
c
      write(ibuf,1000)(ja(j),j=1,i)
1000  format(20a4)
      i1=i*nch
      read(ibuf,1010)(jb(j),j=1,i1)
1010  format(80a1)
      return
      end
c
code for hocase
      subroutine hocase(ja,jb,i)
c--lower case hollerith character
c
c  ja  vector holding the words
c  jb  address in ja vector
c  i   number of words 
c
c--
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      character*80  ibuf
      dimension ja(*)
c      
      write(ibuf,1000)(ja(j),j=jb,jb+i-1)
1000  format(20a4)
      call xcase(ibuf)
      read(ibuf,1000)(ja(j),j=jb,jb+i-1)
      return
      end
c
code for trasf
      subroutine trasf(li,j,k)
c--auxiliary subroutine for transfering data
c
c  li address of store vector
c  j  address of temp vector
c  k  number of words
c
      common/xtemp/ temp(80)
c
      common /xdata/ store(1000000)
c
      li1=li
      j1=j
      do n=1,k
      store(li1)=temp(j1)
      li1=li1+1
      j1=j1+1
      enddo
      return
      end
c
code for szer
      subroutine szer(li,k)
c--auxiliary subroutine for transfering data
c
c  li address of store vector
c  k  number of words
c
      common /xdata/ store(1000000)
c
      li1=li
      do 1000 n=1,k
      store(li1)=0.0
      li1=li1+1
1000  continue
      return
      end
c
code for smov
      subroutine smov(li,j,k)
c--auxiliary subroutine for transfering data
c
c  li address of store vector 'dest'
c  j  address of store vector 'source'
c  k  number of words
c
      common /xdata/ store(1000000)
c
      li1=li
      j1=j
      do 1000 n=1,k
      store(li1)=store(j1)
      li1=li1+1
      j1=j1+1
1000  continue
      return
      end
c
code for jrdfl
      function jrdfl(a,n)
c--read n floating point number
c
c--jrdfl is set as follows on return :
c
c  -1  hash function found or spurious character found
c   0  all blank are encontered
c   1   all the numbers ave been read
c
c--
      common/xchar/id,ie,ib(2),ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
c--
      dimension a(n)
      do i=1,n
      a(i)=0.0
      enddo
      jrdfl=0
      do 1030 i=1,n
      nc=kne(nc,ib,2)
      if(nc) 1010,1010,1020
1010  continue
      return
1020  continue
      if(kredf(a(i),1)) 1040,1030,1040
1030  continue
      jrdfl=1
      return
1040  continue
      jrdfl=-1
      return
      end
c
code for xmtmm
      subroutine xmtmm(a,b,c,l,m,n)
c--general matrix manipulation routines
c  a(l,m).b(m,n)=c(l,n)
      common/xmate/itdf(9), m1d,m2d,n1d,n2d,ichol(20)
      dimension a(*),b(*),c(*)
      m1d=l
      m2d=1
      n1d=1
      n2d=m
      call xmtmr(a,b,c,l,m,n)
      return
      end
c
code for xmtmt
      subroutine xmtmt(a,b,c,l,m,n)
c--a(l,m).b(n,m)'=c(l,n)
      common/xmate/itdf(9), m1d,m2d,n1d,n2d,ichol(20)
      dimension a(*),b(*),c(*)
      m1d=l
      m2d=1
      n1d=n
      n2d=1
      call xmtmr(a,b,c,l,m,n)
      return
      end
c
code for xmttm
      subroutine xmttm(a,b,c,l,m,n)
c--a(m,l)'.b(m,n)=c(l,n)
      common/xmate/itdf(9), m1d,m2d,n1d,n2d,ichol(20)
      dimension a(*),b(*),c(*)
      m1d=1
      m2d=m
      n1d=1
      n2d=m
      call xmtmr(a,b,c,l,m,n)
      return
      end
c
code for xmttt
      subroutine xmttt(a,b,c,l,m,n)
c--a(m,l)'.b(n,m)'=c(l,n)
      common/xmate/itdf(9), m1d,m2d,n1d,n2d,ichol(20)
      dimension a(*),b(*),c(*)
      m1d=1
      m2d=m
      n1d=n
      n2d=1
      call xmtmr(a,b,c,l,m,n)
      return
      end
c
code for xmtmr
      subroutine xmtmr(a,b,c,l,m,n)
c--main matrix multiplication routine
      common/xmate/itdf(9), m1d,m2d,n1d,n2d,ichol(20)
      dimension a(*),b(*),c(*)
      l1=1
      n2=1
      do 1030 j=1,n
      m2=1
      do 1020 i=1,l
      c(l1)=0.
      m1=m2
      n1=n2
      do 1010 k=1,m
      c(l1)=c(l1)+a(m1)*b(n1)
      m1=m1+m1d
      n1=n1+n1d
1010  continue
      l1=l1+1
      m2=m2+m2d
1020  continue
      n2=n2+n2d
1030  continue
      return
      end
c
code for matin
      subroutine matin(a,n,b,m,determ)
c
c--subroutine matin
c--matrix inversion with accompanying solution of linear equations
c
      dimension ipivot(160),a(3,3),b(3,3),index(160,2),pivot(160)
      equivalence (irow,jrow), (icolum,jcolum), (amax, t, swap)
c
c     initialization
c
   10 determ=1.0
   15 do 20 j=1,n
   20 ipivot(j)=0
   30 do 550 i=1,n
c
c     search for pivot element
c
   40 amax=0.0
   45 do 105 j=1,n
   50 if (ipivot(j)-1) 60, 105, 60
   60 do 100 k=1,n
   70 if (ipivot(k)-1) 80, 100, 740
   80 if (abs(amax)-abs(a(j,k))) 85, 100, 100
   85 irow=j
   90 icolum=k
   95 amax=a(j,k)
  100 continue
  105 continue
  110 ipivot(icolum)=ipivot(icolum)+1
c
c     interchange rows to put pivot element on diagonal
c
  130 if (irow-icolum) 140, 260, 140
  140 determ=-determ
  150 do 200 l=1,n
  160 swap=a(irow,l)
  170 a(irow,l)=a(icolum,l)
  200 a(icolum,l)=swap
  205 if(m) 260, 260, 210
  210 do 250 l=1, m
  220 swap=b(irow,l)
  230 b(irow,l)=b(icolum,l)
  250 b(icolum,l)=swap
  260 index(i,1)=irow
  270 index(i,2)=icolum
  310 pivot(i)=a(icolum,icolum)
  320 determ=determ*pivot(i)
c
c     divide pivot row by pivot element
c
  330 a(icolum,icolum)=1.0
  340 do 350 l=1,n
  350 a(icolum,l)=a(icolum,l)/pivot(i)
  355 if(m) 380, 380, 360
  360 do 370 l=1,m
  370 b(icolum,l)=b(icolum,l)/pivot(i)
c
c     reduce non-pivot rows
c
  380 do 550 l1=1,n
  390 if(l1-icolum) 400, 550, 400
  400 t=a(l1,icolum)
  420 a(l1,icolum)=0.0
  430 do 450 l=1,n
  450 a(l1,l)=a(l1,l)-a(icolum,l)*t
  455 if(m) 550, 550, 460
  460 do 500 l=1,m
  500 b(l1,l)=b(l1,l)-b(icolum,l)*t
  550 continue
c
c     interchange columns
c
  600 do 710 i=1,n
  610 l=n+1-i
  620 if (index(l,1)-index(l,2)) 630, 710, 630
  630 jrow=index(l,1)
  640 jcolum=index(l,2)
  650 do 705 k=1,n
  660 swap=a(k,jrow)
  670 a(k,jrow)=a(k,jcolum)
  700 a(k,jcolum)=swap
  705 continue
  710 continue
  740 return
      end
c

      subroutine minv9( a,iv)
c
c---- calcola l'inversa della matrice a e la
c---- memorizza in iv
c---- alfa e' la matrice aggiunta
c
      dimension  a(3,3),iv(9), alfa(3,3)
c
      alfa(1,1)=a(2,2)*a(3,3)-a(2,3)*a(3,2)
      alfa(1,2)=-1*(a(2,1)*a(3,3)-a(2,3)*a(3,1))
      alfa(1,3)=a(2,1)*a(3,2)-a(2,2)*a(3,1)
      alfa(2,1)=-1*(a(1,2)*a(3,3)-a(1,3)*a(3,2))
      alfa(2,2)=a(1,1)*a(3,3)-a(1,3)*a(3,1)
      alfa(2,3)=-1*(a(1,1)*a(3,2)-a(1,2)*a(3,1))
      alfa(3,1)=a(1,2)*a(2,3)-a(1,3)*a(2,2)
      alfa(3,2)=-1*(a(1,1)*a(2,3)-a(1,3)*a(2,1))
      alfa(3,3)=a(1,1)*a(2,2)-a(1,2)*a(2,1)
      det=a(1,1)*alfa(1,1)+a(1,2)*alfa(1,2)+a(1,3)*alfa(1,3)
      l=1
      do 10 i=1,3
      do 10 j=1,3
      iv(l)=alfa(i,j)/det
      l=l+1
10    continue
      return
      end
c
      subroutine minv3( a,b,det)
c
c---- calcola l'inversa della matrice a e la
c---- memorizza in b
c---- alfa e' la matrice aggiunta
c
      dimension  a(3,3),b(3,3), alfa(3,3)
c
      alfa(1,1)=a(2,2)*a(3,3)-a(2,3)*a(3,2)
      alfa(1,2)=-1*(a(2,1)*a(3,3)-a(2,3)*a(3,1))
      alfa(1,3)=a(2,1)*a(3,2)-a(2,2)*a(3,1)
      alfa(2,1)=-1*(a(1,2)*a(3,3)-a(1,3)*a(3,2))
      alfa(2,2)=a(1,1)*a(3,3)-a(1,3)*a(3,1)
      alfa(2,3)=-1*(a(1,1)*a(3,2)-a(1,2)*a(3,1))
      alfa(3,1)=a(1,2)*a(2,3)-a(1,3)*a(2,2)
      alfa(3,2)=-1*(a(1,1)*a(2,3)-a(1,3)*a(2,1))
      alfa(3,3)=a(1,1)*a(2,2)-a(1,2)*a(2,1)
      det=a(1,1)*alfa(1,1)+a(1,2)*alfa(1,2)+a(1,3)*alfa(1,3)
      l=1
      do i=1,3
      do j=1,3
      b(i,j)=alfa(j,i)/det
      enddo
      enddo
      return
      end
c
code for xmv3
      subroutine xmv3(g,a,b)
c--matrix * vector multiplicatio
c  g matrice input
c  a vettore input
c  c vettore output
c
      dimension g(3,3),a(3),b(3)
      do i=1,3
      b(i)=0.0                                                                  
      do l=1,3
      b(i)=b(i)+g(i,l)*a(l)
      enddo
      enddo
      return                                                                    
      end                                                                       
c
code for xmm3
      subroutine xmm3(a,b,c)
c--matrix * matrix multiplication
c--c(i,j) = a(i,k)*b(k,j)
c  a matrice input
c  b matrice input
c  c matrice output
c
      dimension a(3,3),b(3,3),c(3,3)
      do j=1,3
      do m=1,3
      c(j,m) = 0.0
      do n=1,3
      c(j,m)=c(j,m)+a(j,n)*b(n,m)
      enddo
      enddo
      enddo
      return                                                                    
      end                                                                       
c
code for xtrig
      subroutine xtrig
c--calculate trigonometric tables
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr
      common/trig/stable(450),stab24(36)
      dimension ctable(1),ctab24(1)
      equivalence (stable(91),ctable(1))
      equivalence (stab24(5),ctab24(1))
c--
      rtd=180.0/pi
      dtr=pi/180.0
      do i=1,450
      stable(i)=sin(dtr*float(i-1))
      enddo
      stable(1)=0.
      stable(91)=1.0
      stable(181)=0.
      stable(271)=-1.
      stable(361)=0.
      dtr24=pi/12
      do i=1,36
      stab24(i)=sin(dtr24*float(i-1))
      enddo
      stab24(1)=0.
      stab24(7)=1.
      stab24(13)=0.
      stab24(19)=-1.
      stab24(25)=0.
      return
      end
c-----------------------------------------------------------------------
      subroutine shift(string,lenp)
      character string*(*)
      character blank,digit*12,card(100)*80
      common /chara/ blank,digit,card
c
      k=len(string)
c
c-- TAB filter
c
      do 5 i=1,k
      j = ichar(string(i:i))
      if (j.eq.9) string(i:i)=blank
    5 continue
      ifin=1
      do 10 i=1,k
      if (string(i:i).ne.blank) then
                                  iniz=i
                                  go to 20
                                endif
   10 continue
      lenp=-1
      return
   20 do 30 i=k,1,-1
      if (string(i:i).ne.blank) then
                                  ifin=i
                                  go to 40
                                endif
   30 continue
   40 continue
      lenp=ifin-iniz+1
      if (iniz.eq.1) return
      do 50 i=1,lenp
      j=iniz+i-1
   50 string(i:i)=string(j:j)
      if (lenp.eq.k) return
      do 60 i=lenp+1,k
   60 string(i:i)=blank
      return
      end
!-----------------------------------------------------------------------
      subroutine zshift(string,lenp)
      character string*(*)
!
      k=len(string)
!
!-- TAB filter
!
      do i=1,k
         j = ichar(string(i:i))
c--	 if (j.eq.9) then
         if (j.lt.32.or.j.ge.127) then
             string(i:i)=' '
         endif
      enddo
      ifin=1
      iniz=1
   20 do 30 i=k,1,-1
         if (string(i:i).ne.' ') then
             ifin=i
             go to 40
         endif
   30 continue
   40 continue
      lenp=ifin-iniz+1
c
      return
      end
!-----------------------------------------------------------------------
      subroutine cutst(string,lens,dire,lend)
      character string*(*),dire*(*)
      character blank,digit*12,card(100)*80
      common /chara/ blank,digit,card
c
      k=len(dire)
      do 5 i=1,k
    5 dire(i:i)=blank
      k=len(string)
      do 10 i=1,k
      if (string(i:i).eq.blank) then
                                  iniz1=i
                                  go to 20
                                endif
   10 continue
   20 continue
      lend=min0(iniz1-1,40)
      do 25 i=1,lend
      dire(i:i)=string(i:i)
   25 string(i:i)=blank
      call shift(string,lens)
      return
      end
c----------------------------------------------------------------------
      subroutine ucase(line)
      character*(*) line
      character*52 ulc
      common /ulcase/ ulc
      character a
c
      k=len(line)
      do 20 i=1,k
      a=line(i:i)
      l=0
      do 10 j=1,26
      if (a.eq.ulc(j:j)) l=j
   10 continue
      if (l.ne.0) line(i:i)=ulc(l+26:l+26)
   20 continue
      return
      end
c----------------------------------------------------------------------
      subroutine lcase(line)
      character*(*) line
      character*52 ulc
      common /ulcase/ ulc
      character a
c
      k=len(line)
      do 20 i=1,k
      a=line(i:i)
      l=0
      do 10 j=27,52
      if (a.eq.ulc(j:j)) l=j
   10 continue
      if (l.ne.0) line(i:i)=ulc(l-26:l-26)
   20 continue
      return
      end
c-----------------------------------------------------------------------
      block data sirblk
      character beg,commen
      character blank,digit*12,card(100)*80
      character fname(15)*80,ext(15)*4,path*80
      common/dotdat/ fname,ext,path
      common /SWareRC/ SWRC, HOMEdir, CAOSdir
      character*80 SWRC, HOMEdir, CAOSdir
      integer color, xo, yo, khead
      character*52 ulc
      character*80 Titolo
      integer AngDef
c
      common /xdata/ store(1000000)
      common /charas/ beg,commen
      common /chara/ blank,digit,card
c      common/trig/sint(450),pi,twopi,dtor,rtod
c      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
c      common / ureq1/ jpatt,jpunt(1501),ksacc,jseteq,jumpp,jmpsie,nsec
c      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(500),lsx,
c     * 	     oscale,errem,fomin,tsigma,maxcyc,jrest
      common /scale/ x11scale(2),x11disp(2),ragmed,deltax,deltay
      common/xwi/ color,xo,yo,khead,Species,NumSpec,ihcopy,ipres,jpres
      common /chc/ kconth,nSelect,lmi(60,4),nhot,nHook(60,3)
      common /ccurs/ ifwatch, mcShape
c      common/dotdat/ fname,ext,path
      common /sirtxt/ sirtx,jhelp,ffile,sirpal,jwrpal,iasun,ciffle
      common /ulcase/ ulc
      common /lsq1/ nWeight,Dampi,nCycles,iCutoff,LsqType,ifDefault,iW12
      common /contr/ NF,iFirstTime,Titolo,Ratio,ifCont,ifEdge,ifScale,
     *               kplty, ifDrRes,AngDef,PercTra,ViewDist,ifChangedXYZ
      common /contr1/ ifGhost,ifDrHydr,FProb,ifHardC,ifHBridge,ifContour
c      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
c      common /restr/rescon(6),vres(6000),nres,wq,dmean,amean,nplane,mres
c      common/bigcom/ maxstr,maxpsi
c      common /restw/ dfr(3,500),qvr(3,500),kblock(500)
      common /fonte/ FntType,FntAscent,FntPixWidth,FntPixHeight,
     *               FntAvgWidth
      common /WildRun1/ nWsymb,nWrand,kWstop,NoWild
      common /WildRun2/ nwild,nWDelay,kWDelay,iverbo,interv,errev(101)
      common /pkitc/ kit,kitvet(35)
c      common /swc/ kpunti(3,4),nswp(2,8),ksw(2,217)
      common /crisTest/ ktest
c
      data kit/2/
c
      data ktest/0/
      data FntType,FntAscent,FntPixWidth,FntPixHeight,FntAvgWidth
     *    /  0    ,    10   ,    10     ,   15       ,   10     /
c
      data ulc/'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'/
c
      data blank/' '/
      data digit/'0123456789.-'/
      data beg,commen /'%','>'/
c--   graphics
      data ifCont,ifEdge,ifScale,IfGhost,ifDrRes,ifDrHydr,ifChangedXYZ
     *      /0,      0,     1,     1,       0,      1,         0/
      data nWeight,Dampi,nCycles,iCutoff,LsqType,ifDefault,ifContour
     *      /6,     1.,    11,      3,      2,       0,       0/
      data deltax,deltay /88.0 , 0.0/
      data ihcopy,ipres,jpres / 0, 0, 0/
c      data iprin/0/
c-- kconth = 0 the contestual help window can be activated
c--          1 the contestual help window cannot
      data kconth /0/
c-- ifwatch=1 the watch (or similar) shape is active for mouse cursor
c-- ifwatch=0 the pointer (or similar) shape is active for mouse cursor
      data ifwatch ,mcShape/0, 0/
c
      data jhelp /44/
c-- jwrpal = 1 if SirPal.pal can be modified, = 0 otherwise
      data jwrpal /1/
      data path  /  ' ' 	 /
c     *** warning *** if the user wants to change the lenght of these
c                     default name and/or extension he must modify
c                     also in the subroutine 'spoolr' the relative
c                     assignement statements
c
      end
c
code for xparen 
      subroutine xparen(ivet)
c--strip away ( ) characters
c  ivet character  string 
c
      character*(*) ivet
      character*1 para,parc,blank
      data para  /'('/ 
      data parc  /')'/
      data blank /' '/
c
      k1=len(ivet)
      k=k1
      do i=1,k
        if(ivet(i:i).eq.para.or.ivet(i:i).eq.parc) then
          if(i.lt.k) then
            do j=i,k-1
             ivet(j:j)=ivet(j+1:j+1)
            enddo                   
          endif
          k=k-1
        endif 
      enddo
      if(k.lt.k1) then
        do i=k+1,k1
         ivet(i:i)=blank
        enddo     
      endif
      return
      end
